<!doctype html>
<html>
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">
  
  <title>reveal.js</title>
  
  <link rel="stylesheet" href="dist/reset.css">
  <link rel="stylesheet" href="dist/reveal.css">
  <link rel="stylesheet" href="dist/theme/moon.css" id="theme">
  
  <!-- Theme used for syntax highlighted code -->
  <link rel="stylesheet" href="plugin/highlight/monokai.css" id="highlight-theme">
  <link rel="stylesheet" href="css/gradient.css" id="highlight-theme">
  <style>
  </style>
</head>
<body>
  <div class="reveal">
    <div class="slides">
      <section>
        <h1>CSS : les gradients</h1>
        <div id="gradient-boxes"></div>
      </section>
      <section>
             
        <section>
          <h2>Qu'est-ce qu'un gradient ?</h2>
          <ul>
            <li class="fragment">Un gradient est un dégradé de couleur.</li>
            <li class="fragment">Il peut être appliqué via la propriété <code>background</code>.</li>
            <li class="fragment">Il est défini par une direction et plusieurs paliers de couleurs.</li>
            <li class="fragment">La taille de la couleur dépend de l'élément coloré.</li>

          </ul>
        </section>     
        <section>
          <h2>Les paramètres de cette fonction</h2>
          <ul>
            <li class="fragment">Side or corner : <code>(to) left</code>, <code>(to) right</code>, <code>(to) top</code>, <code>(to) bottom</code></li>
            <li class="fragment">Angle de direction du dégradé,</li>
            <li class="fragment">Linear color stop : Valeur numérique du fondu de la couleur,</li>
            <li class="fragment">Color hint : Emplacement de la couleur moyenne entre deux couleurs.</li>
          </ul>
        </section>
        <section>
          <h2 id="linear-gradient-target" class="rounded">Le gradient linéaire</h2>
          <p>Le gradient linéaire se diffuse en suivant une ligne droite.</p>
          <input type="text" id="linear-gradient-input" value="linear-gradient(to right, red, yellow)">
          
          <aside class="notes">
            Modifier un peu la règle pour montrer
          </aside>
        </section>
        <section>
          <h2 id="radial-gradient-target" class="rounded">Le gradient radial</h2>
          <p>Le gradient radial se diffuse dans toutes les directions à partir d'un point central.</p>
          <input type="text" id="radial-gradient-input" value="radial-gradient(circle, blue 20%, white 80%)">
        </section>
        <section>
          <h2 id="conic-gradient-target" class="rounded">Le gradient conique</h2>
          <input type="text" id="conic-gradient-input" value="conic-gradient(red, blue)">
        </section>
        <section>
          <h2 id="repeated-gradient-target" class="rounded">Le gradient répété</h2>
          <p>Le gradient peut être répété.</p>
          <input type="text" id="repeated-gradient-input" value="repeating-linear-gradient(45deg, blue 0%, red 10%, blue 20%)">
        </section>
        <section>
          <h2 id="repeating-radial-gradient-target" class="rounded">Le gradient radial répété</h2>
          <input type="text" id="repeated-radial-gradient-input" value="repeating-radial-gradient(blue 5%, red 5%, blue 15%)">
        </section>
      </section>
      <section>
        <section>
          <h2>Compatibilité avec les navigateurs</h2>
          <img src="images/compatibilite_css_gradient.png" height="600px">
        </section>
        <section>
          <h2>Documentation</h2>
          <ul>
            <li class="fragment"><a href="https://developer.mozilla.org/fr/docs/Web/CSS/linear-gradient">Developper Mozilla</a></li>
            <li class="fragment"><a href="https://www.w3schools.com/css/css3_gradients.asp">W3schools</a></li>
          </ul>
        </section>
        <section>
          <h2>Générateurs de gradients</h2>
          <ul>
            <li class="fragment"><a href="https://uigradients.com/#CoolBrown">Ui Gradients</a></li>
            <li class="fragment"><a href="https://mycolor.space/gradient">My color space</a></li>
            <li class="fragment"><a href="https://cssgradient.io/">Css Gradient</a></li>
          </ul>
        </section>
      </section>
    </section>
  </div>
</div>

<script src="dist/reveal.js"></script>
<script src="plugin/notes/notes.js"></script>
<script src="plugin/markdown/markdown.js"></script>
<script src="plugin/highlight/highlight.js"></script>
<script>
  // More info about initialization & config:
  // - https://revealjs.com/initialization/
  // - https://revealjs.com/config/
  Reveal.initialize({
    hash: true,
    
    // Learn about plugins: https://revealjs.com/plugins/
    plugins: [ RevealMarkdown, RevealHighlight, RevealNotes ]
  });
</script>
<script>
  /**
  * Generate random gradients boxes for the first slides
  */
  const gradientBoxes = document.getElementById('gradient-boxes');
  const randomRgbColor = () => {
    const red = Math.ceil(Math.random() * 255);
    const blue = Math.ceil(Math.random() * 255);
    const green = Math.ceil(Math.random() * 255);
    return `rgb(${red},${green},${blue})`;
  }
  for (let i = 0; i < 8; i += 1) {
    const gbox = document.createElement('div');
    
    const side = 50 + Math.floor(Math.random() * 50);
    const rotation = Math.floor(Math.random() * 360);
    const color1 = randomRgbColor();
    const color2 = randomRgbColor();
    const color3 = randomRgbColor();
    
    gbox.style.setProperty('width', `${side}px`);
    gbox.style.setProperty('height', `${side}px`);
    gbox.style.setProperty('border-radius', '50%');
    
    if (Math.random() < 0.5) {
      gbox.style.setProperty('background', `linear-gradient(${rotation}deg, ${color1}, ${color2}, ${color3})`);
    } else {
      gbox.style.setProperty('background', `radial-gradient(circle, ${color1}, ${color2}, ${color3})`);
    }
    
    gradientBoxes.appendChild(gbox);
  }
  
  /**
  * Use the value of an input as background for another element
  */
  function linkInputToGradient(inputId, targetId) {
    const target = document.getElementById(targetId);
    const gradientInput = document.getElementById(inputId);
    
    target.style.setProperty('transition', 'background 1s');
    
    const updateTargetStyles = () => {
      target.style.setProperty('background', gradientInput.value);
    }
    
    updateTargetStyles();
    gradientInput.addEventListener('input', updateTargetStyles);
  }
  
  linkInputToGradient('linear-gradient-input', 'linear-gradient-target');
  linkInputToGradient('radial-gradient-input', 'radial-gradient-target');
  linkInputToGradient('repeated-gradient-input', 'repeated-gradient-target');
  linkInputToGradient('conic-gradient-input', 'conic-gradient-target');
  linkInputToGradient('repeated-radial-gradient-input', 'repeating-radial-gradient-target');

</script>
</body>
</html>
